<?php

  /*
   This file is part of MoreGroupWare's webmail2 module
   Copyright 2004-2005 Franky Van Liedekerke
   This module is released under the GPL (as stated below).

   Originally written by Thomas Bley (info@simple-groupware.de),
   now adapted and maintained by Franky Van Liedekerke.

   You should have received a copy of the GNU General Public License
   along with mgw; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

function get_group_members ($key) {
  global $conn;
  $result = array();
  $sql = "select userid,username from mgw_groups_members, mgw_users where groupid=".(int)$key." and mgw_users.id=mgw_groups_members.userid";
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  while ($row = $res->FetchRow()) {
     $result[$row["userid"]] = $row["username"];
  }
  return $result;
}

function get_group_members_contacts ($key) {
  global $conn,$user_id;
  $result = array();

  if (isModuleInstalled("contact")) {
  $sql = "select email from mgw_contacts where groupid=".(int)$key." and email<>'' and (ispublic=1 or owner=".(int)$user_id.") order by lastname";
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  while ($row = $res->FetchRow()) {
    $result[$row["email"]] = $row["email"];
  }

  $sql = "select email from mgw_companies where groupid=".(int)$key." and email<>'' and (ispublic=1 or owner=".(int)$user_id.") order by name1";
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  while ($row = $res->FetchRow()) {
    $result[$row["email"]] = $row["email"];
  }
  }

  return $result;
}

function add_adr_to_arr($tolocalarr, $tolocalarrgroup, $input, $togroup_contacts) {
  global $MGW;
  
  $arr=$input;
  $my_tolocalarr = array();
  $my_tolocalarrgroup = array();
  $my_togroup_contacts = array();

  // $users is an aray with index userid, value username
  $users = getallusers_id_username();
  // $users2 is an array with index username, value email
  $users2 = getallusers_name_email();
  // $groups is an array with index groupid, value groupname
  $groups = getallgroups();
  // $groups_contacts is an array with groups from the contact module
  $groups_contacts = getallgroups_contacts();

  foreach ($arr as $key=>$key2) {
    if ($key2 != "") {
      $key2 = strtolower($key2);
      // if a group
      if ($key2[0] == "@") {
	// remove the @
        $key2 = substr($key2,1);

        if (in_array($key2,$groups) and !in_array($key2,$tolocalarrgroup)) {
		  if (isset($MGW->settings["wm2_disable_local_send"]) and $MGW->settings["wm2_disable_local_send"]) {
		    $members = get_group_members(array_search($key2,$groups));
		    foreach ($members as $key3=>$key4) {
			if (isset($users2[$key4])) $arr[] = $users2[$key4];
		    }
		    unset($arr[$key]);
		  } else {
          	    $my_tolocalarrgroup[array_search($key2,$groups)] = $key2;
          	    unset($arr[$key]);
		  }
        } elseif (in_array($key2,$groups_contacts) and !in_array($key2,$togroup_contacts)) {
          $my_togroup_contacts[array_search($key2,$groups_contacts)] = $key2;
          unset($arr[$key]);
        } elseif (in_array($key2,$groups) and in_array($key2,$tolocalarrgroup)) {
          unset($arr[$key]);
        }
      } else {
        if (in_array($key2,$users) and !in_array($key2,$tolocalarr)) {
		  if (isset($MGW->settings["wm2_disable_local_send"]) and $MGW->settings["wm2_disable_local_send"]) {
		    $arr[$key] = $users2[$key2];
		  } else {
          	    $my_tolocalarr[array_search($key2,$users)] = $key2;
          	    unset($arr[$key]);
		  }
        } elseif (in_array($key2,$users) and in_array($key2,$tolocalarr)) {
          unset($arr[$key]);
        }
      }
    }
  }
  $result=array($my_tolocalarr,$my_tolocalarrgroup,$arr,$my_togroup_contacts);
  return $result;
}

function make_array_adr($str) {
  $result = array();
  if ($str != "") {
    $arr = explode(",",$str);
    foreach ($arr as $key=>$key2) {
      $result[] = getmailadr(trim($key2));
    }
  }
  return $result;
}

function getallgroups() {
  global $conn;
  $sql = "select name,id from mgw_groups";
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  $groups = array();
  while ($row = $res->FetchRow()) {
    $groups[$row["id"]] = strtolower($row["name"]);
  }
  return $groups;
}

function getallgroups_contacts() {
  global $conn;
  $groups = array();

  if (isModuleInstalled("contact")) {
     $sql = "select name_key,id from mgw_contacts_groups";
     if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
     while ($row = $res->FetchRow()) {
       $groups[$row["id"]] = strtolower($row["name_key"]);
     }
  }
  return $groups;
}

function delete_open_attachments($webmail_sendmail_temp_dir) {
  $handle=opendir($webmail_sendmail_temp_dir);
  while ($file = readdir($handle)) {
    $file1 = strstr($file,session_id());
    if ($file1) {
      if (file_exists($webmail_sendmail_temp_dir.$file)) {
        unlink($webmail_sendmail_temp_dir.$file);
      }
    } 
  }
  closedir($handle);
}

function writetofile_sendmail($act_name,$body,$feed="\n") {
  global $mail_attachments;

  $fd = fopen($act_name, "wb");

  if (count($mail_attachments)!=0) {
    $data2 = explode($feed,$body);

    foreach ($data2 as $line) {
      if (in_array($line,$mail_attachments) and file_exists($line)) {

        $filename = basename($line);
        $ext = strtolower(substr($line,-strpos(strrev($line),'.')));

        if($fp = fopen($line, 'rb')){
          while(!feof($fp)){
            $line3 = fread($fp, 1440);
            if ($ext!="eml" and $ext!="ics" and $ext!="vcs" and $filename!="rfc822") {
              $line3 = rtrim(chunk_split(base64_encode($line3), 72, $feed));
            }
		    $result = fwrite($fd, $line3.$feed);
	  	  }
		  fclose($fp);
        }
      } else {
        // undo the doubling of dots at the beginning of a line
	$patterns[0]="/^\.\./";
	$patterns[1]="/\n\.\./";
	$replacements[0]=".";
	$replacements[1]="\n.";
	$line = preg_replace ($patterns, $replacements, $line);
        fwrite($fd, $line.$feed);
      }
    }
  } else {                
    // undo the doubling of dots at the beginning of a line
    $patterns[0]="/^\.\./";
    $patterns[1]="/\n\.\./";
    $patterns[2]="/\r\n/";
    $replacements[0]=".";
    $replacements[1]="\n.";
    $replacements[2]="\n";
    $body = preg_replace ($patterns, $replacements, $body);
    fwrite($fd, $body);
  }
  fclose($fd);
}

function check_pop_sendmail($row,$saveto,$i) {
  global $back_button,$password;
  if ($row["popbeforesmtp"]=="checked" and $saveto != "draft" and $i != 0) {
    require_once(WM2_INC_DIR.'class.pop3.php');
    $email = new pop3();

    if (!$email->connect($row["pophost"]) ) {	show_webmail_error($back_button.Lang::getLanguageString("sendmail_popbeforesmtpfailed_host"),""); }
    if (!$email->user($row["username"]) or $email->pass($password)<0){ show_webmail_error($back_button.Lang::getLanguageString("sendmail_popbeforesmtpfailed_userpwd"),""); }
  }
}

function add_attachments_sendmail($webmail_sendmail_temp_dir) {
  global $mime;
  require_once (WM2_INC_DIR.'mimetype.php');

  $attaches = 0;
  $handle=opendir($webmail_sendmail_temp_dir);
  while ($file = readdir($handle)) {
    $file1 = strstr($file,session_id());
    if ($file1) {
          $attach_name = urldecode(substr(strstr($file,"######"),6));
	  $ext = strtolower(substr($attach_name,-strpos(strrev($attach_name),'.')));
	  if ($attach_name=="rfc822" or $ext=="eml") {
	    $mime->addAttachment($webmail_sendmail_temp_dir.$file, 'message/rfc822', $attach_name, true, '7bit');
	  } else {
	    $mimetype = new mimetype();
	    $type=$mimetype->getType($file);
            $mime->addAttachment($webmail_sendmail_temp_dir.$file, $type, $attach_name);
	    unset($mimetype);
	    unset($type);
	  }
    }
  }
  closedir($handle);
  return $attaches;
}

function add_to_replied($replyto2,$msg_id,$to22) {
  global $conn;
  
  $sql = "select replied from mgw_webmail2_messages where message_id=".(int)$replyto2;
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  $row2 = $res->FetchRow();

  if (!isset($row2["replied"]) or $row2["replied"]=="") { $replied = "'".time().";#;".$to22.";#;".$msg_id.";@;'"; } else { $replied = $conn->concat("'".time().";#;".$to22.";#;".$msg_id.";@;'","replied");}

  $sql = "update mgw_webmail2_messages set replybit=1,replied=".$replied." where message_id=".(int)$replyto2;
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
}

function add_to_forwarded($forward,$msg_id,$to22) {
  global $conn;
  
  $sql = "select forwarded from mgw_webmail2_messages where message_id=".(int)$forward;
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  $rowforward = $res->FetchRow();

  if (!isset($rowforward["forwarded"]) or $rowforward["forwarded"]=="") { $forwarded = "'".time().";#;".$to22.";#;".$msg_id.";@;'"; } else { $forwarded = $conn->concat("'".time().";#;".$to22.";#;".$msg_id.";@;'","forwarded");}

  $sql = "update mgw_webmail2_messages set forwardbit=1,forwarded=".$forwarded." where message_id=".(int)$forward;
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
}

function localgroup_to_arr($var1,$var2) {
  $result=array();
  foreach ($var1 as $key=>$key2) {
    $members = get_group_members($key);
    foreach ($members as $key3=>$key4) {
      if (!in_array($key4,$var2)) { $result[] = $key4; }
    }
  }
  return $result;
}

function group_to_arr($var1,$var2) {
  $result=array();
  foreach ($var1 as $key=>$key2) {
    $members = get_group_members_contacts($key);
    foreach ($members as $key3=>$key4) {
      if (!in_array($key4,$var2)) { $result[] = $key4; }
    }
  }
  return $result;
}

?>
