<?php
/******************************************************************************
 * File:				user.list.php
 * Description:			show all users
 * Authors:				Bastian Pttner		bastian@poettner.net
 *						Thorsten Rinne		thorsten@rinne.info
 * Date:				2003-02-21
 * Last change:			2004-01-24
 * Copyright:           (c) 2001-2002 Thorsten Rinne und Bastian Pttner
 *                      (c) 2001-2004 Thorsten Rinne
 * 
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 ******************************************************************************/
if ((allowed(getright("edituser"), $auth_user) == 1 || allowed(getright("deluser"), $auth_user) == 1 || allowed(getright("adduser"), $auth_user) == 1)) {
	$perpage = 20;
    $pages = 1;
	if (!isset($_REQUEST["pages"])) {
		$anz = $db->num_rows($db->query("SELECT id FROM ".$sqltblpre."faquser"));
		$pages = ceil($anz / $perpage);
		if ($pages < 1) {
			$pages = 1;
			}
		}
	else {
		$pages = $_REQUEST["pages"];
		}
	
	if(!isset($_REQUEST["page"])) {
		$page = 1;
		}
	else {
		$page = $_REQUEST["page"];
		}
	
	$start = ($page - 1) * $perpage;
	
	$ende = $perpage;
?>
	<h3><?php print $ad_user ?></h3>
	<table width="100%" border="0" cellspacing="1" cellpadding="2" bgcolor="#778899">
	<tr bgcolor="#f5f5f5">
		<td><b>#</b></td>
		<td><b><?php print $ad_user_username; ?></b></td>
		<td><b><?php print $ad_user_rights; ?></b></td>
		<td><b><?php print $ad_user_action; ?></b></td>
	</tr>
<?php
		$result = $db->query("SELECT id, name, realname, rights FROM ".$sqltblpre."faquser LIMIT ".$start.", ".$perpage);
		while(list($id, $user, $realname, $rights) = $db->fetch_row($result)) {
?>
	<tr bgcolor="#f5f5f5">
		<td valign="top"><?php print $id; ?></td>
		<td valign="top"><span title="<?php print $realname; ?>"><?php print $user; ?></span></td>
		<td valign="top"><?php print $rights; ?></td>
		<td align="center"><a href="<?php print $_SERVER["PHP_SELF"].$linkext; ?>&amp;aktion=useredit&amp;id=<?php print $id; ?>" title"<?php print  $ad_user_edit; ?>"><img src="images/edit.gif" width="32" height="32" alt="<?php print  $ad_user_edit; ?>" border="0"></a><?php if (strtolower($user) != "admin") { ?>&nbsp;&nbsp;<a href="<?php print $_SERVER["PHP_SELF"].$linkext; ?>&amp;aktion=userdel&amp;id=<?php print $id; ?>" title="<?php print $ad_user_delete; ?>"><img src="images/trash.gif" width="32" height="32" alt="<?php print $ad_user_delete; ?>" border="0"></a><?php } ?></td>
	</tr>
<?php
			}
		if ($pages > 1) {
?>
	<tr bgcolor="#ffffff">
		<td colspan="4" align="right"><?php	print PageSpan("<a href=\"".$_SERVER["PHP_SELF"].$linkext."&amp;aktion=user&amp;page=<NUM>&amp;pages=".$pages."\">", 1, $pages, $page); ?></td>
	</tr>
<?php
			}
?>
	<tr bgcolor="#f5f5f5">
		<td colspan="4" align="center">
		<b>[ <a href="<?php print $_SERVER["PHP_SELF"].$linkext; ?>&amp;aktion=useradd"><?php print $ad_user_add ?></a> ]</b>
		</td>
	</tr>
	</table>
<?php
	}
else {
	na();
	}
?>
