<?php
/******************************************************************************
 * File:				database.php
 * Description:			database class for MySQL
 * Author:				Thorsten Rinne			thorsten@rinne.info
 * Portions of this Code is based on work by
 *						Meikel Katzengreis		meikel@katzengreis.com
 * Date:				2003-02-24
 * Last Update:			2003-11-20
 * Copyright:           (c) 2001-2003 Thorsten Rinne
 * 
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 ******************************************************************************/

class db_mysql {
	
	var $conn = false;
	var $queries = 0;
	var $sqllog = "";
	
	// connect to server and select database
	function &connect ($host, $user, $passwd, $db) {
		$this->conn = @mysql_connect($host,$user,$passwd);
		if (empty($db) OR $this->conn == false) {
			print "<p align=\"center\">The connection to the MySQL server could not be established.</p>\n";
			print "<p align=\"center\">The error message of the MySQL server:<br />".mysql_error()."</p>\n";
			return false;
			}
		return @mysql_select_db($db, $this->conn);
		}
	// send a query
	function &query ($query) {
		$this->sqllog .= $query."<br>\n";
		$this->queries++;
		$ret = @mysql_query($query, $this->conn);
        return $ret;
		}
	// fetch a result row as an object
	function &fetch_object ($result) {
		$ret = @mysql_fetch_object($result);
        return $ret;
		}
	// fetch a result row
	function &fetch_row ($result) {
		$ret = @mysql_fetch_row($result);
        return $ret;
		}
	// fetch a row as an array
	function &fetch_assoc ($result) {
		$ret = @mysql_fetch_assoc($result);
        return $ret;
		}
	// fetch a result row
	function &num_rows ($result) {
		$ret = @mysql_num_rows($result);
        return $ret;
		}
	// get the last id
	function &insert_id () {
		$ret = @mysql_insert_id($this->conn);
        return $ret;
		}
	// prints the count of queries
	function &countqueries() {
		$ret = $this->queries;
        return $ret;
		}
	// prints the count of queries
	function &sqllog() {
		$ret = $this->sqllog;
        return $ret;
		}
	// closes a connection
	function &dbclose() {
		$ret = @mysql_close($this->conn);
        return $ret;
		}
	}

?>